﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import com.actionscriptfacile.ui.text.UITextField;

	import com.as3facile.DefaultButton;

	import flash.events.MouseEvent;
	
	import com.demonsters.debugger.MonsterDebugger;
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	
	
	// definit la couleur de fond du swf
	[SWF(backgroundColor="0xffffff")] 

	public class Main extends Sprite
	{
		private var iCptGlobe : int;// compteur de tour des globes
		
		private var bTerreStart : Boolean = false;// pour déterminer si l'animation est lancée
		
		private var oInfosGlobe : UITextField;// texte modifié en fonction de l'image de l'animation
		private var oTerre : Terre;
		private var oTerreMini : Terre;
		
		// pour compenser le décalage 0;0 du clip dans le fichier fla
		private var iCoordXcorrect : int = 182;
		private var iCoordYcorrect : int = 178;
		
		

		/**
		 * Constructeur.
		 * 
		 * Compiler avec le SDK Flex 4.6
		 * 
		 * -swf-version = 18 : pour l'API Flash Player 11.5
		 * -default-frame-rate 40 : nombre d'images par secondes
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * 
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Animation");
			
			this.buildUI();
		}


		/**
		 * Construit l'affichage de l'application.
		 * 
		 * 
		 */
		private function buildUI() : void
		{ 	
			oTerre = new Terre();
			oTerre.x = 10 + iCoordXcorrect;
			oTerre.y = 10 + iCoordYcorrect;
			oTerre.stop();// stop l'animation de la terre
			this.addChild(oTerre);
			
			
			oTerreMini = new Terre();
			oTerreMini.scaleX = 0.4;
			oTerreMini.scaleY = 0.4;
			oTerreMini.x = 369 + iCoordXcorrect*.4;
			oTerreMini.y = 80 + iCoordYcorrect*.4;
			oTerreMini.stop();// stop l'animation de la terre
			this.addChild(oTerreMini);
			
			// ajout d'un texte informatif
			oInfosGlobe = this.addText("Nombre de tour du Globe : 0");
			oInfosGlobe.x = 180;
			oInfosGlobe.y = 369;
			this.addChild(oInfosGlobe);
			
			iCptGlobe = 0;
			
			// Création du bouton pour le menu contextuel
			var oBtnStartGame:DefaultButton = new DefaultButton();
			oBtnStartGame.getObject().label = "Start / Stop";
			oBtnStartGame.getObject().x = stage.stageWidth - oBtnStartGame.width - 40;
			oBtnStartGame.getObject().y = 33;
			oBtnStartGame.getObject().addEventListener ( MouseEvent.CLICK, onStartRotation );
			this.addChild(oBtnStartGame);
		}


		/**
		 * Lance / stopppe la rotation des Terres dès l'appui sur le bouton.
		 * 
		 */
		private function onStartRotation(event : MouseEvent) : void
		{
			// si le compteur n'est pas activé, lance le démarrage
			if( !bTerreStart )
			{
				MonsterDebugger.trace(this, "Terre tourne");
				bTerreStart = !bTerreStart;
				
				// envoie un évènement à chaque image par secondes
				stage.addEventListener(Event.ENTER_FRAME, onEnterFrame);

				oTerre.play();// lance l'animation de la terre
				oTerreMini.play();// lance l'animation de la terre
			}
			else
			{
				MonsterDebugger.trace(this, "Terre immobile");
				bTerreStart = !bTerreStart;
				
				// supprime l'évènement, il n'est plus utilisé
				stage.removeEventListener(Event.ENTER_FRAME, onEnterFrame);
				
				oTerre.stop();// stop l'animation de la terre
				oTerreMini.stop();// stop l'animation de la terre
				
				oTerreMini.gotoAndStop ("departglobe");// choisit l'image de départ de l'animation
				
				iCptGlobe = 0;// remise à zéro du compteur
				oInfosGlobe.text = "Nombre de tour du Globe : "+iCptGlobe;
				
			}
		}


		
		/**
		 * Appel à chaque image par secondes.
		 * 
		 */
		private function onEnterFrame(event : Event) : void
		{
			// récupère le nom de l'image en cours dans l'animation Terre
			if( oTerre.currentFrameLabel == "tourglobe")// ou avec oTerreMini.currentFrameLabel == "tourglobe"
			{
				iCptGlobe++;
				oInfosGlobe.text = "Nombre de tour du Globe : "+iCptGlobe;
			}
		}


	
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("bold", true);
			oTxtField.changeFormat("size", 26);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			
			return oTxtField;	 
		}		


	}
}
